Graphics 400, 400, 0, 2

AppTitle "Symmetrieachsen-Finder"

Local Pfad$ = CommandLine()
If Pfad = "" Then RuntimeError "Bitte per Drag 'n' Drop Bild auf die Exe fallen lassen!"
Pfad = Replace(Pfad, Chr(34), "")
If FileType(Pfad) = 0 Then RuntimeError Pfad

Local Bild = LoadImage(Pfad)
Local Seite = ImageWidth(Bild)
Local MS = MilliSecs()

;==[Pixel einlesen]------------------------------------------------------------
Local X, Y
Dim Feld(Seite - 1, Seite - 1)

LockBuffer ImageBuffer(Bild)
For X = 0 To Seite - 1
	For Y = 0 To Seite - 1
		Feld(X, Y) = ReadPixelFast(X, Y, ImageBuffer(Bild))
		Feld(X, Y) = ((Feld(X, Y) And $FF0000) Shr 16) * 0.299 + ((Feld(X, Y) And $FF00) Shr 8) * 0.587 + (Feld(X, Y) And $FF) * 0.114
	Next
Next
UnlockBuffer ImageBuffer(Bild)

;==[Hintergrundfarbe ermitteln; Differenz im Feld speichern]-------------------
Local Hintergrund = Feld(0, 0)

For X = 0 To Seite - 1
	For Y = 0 To Seite - 1
		Feld(X, Y) = Feld(X, Y) - Hintergrund
	Next
Next

;==[Schwerpunkt ermitteln]-----------------------------------------------------
Local SchwerX#, SchwerY#, A#
Dim AnzahlX#(Seite - 1), AnzahlY#(Seite - 1)
For X = 0 To Seite - 1
	For Y = 0 To Seite - 1
		AnzahlX(Y) = AnzahlX(Y) + Feld(X, Y)
		AnzahlY(X) = AnzahlY(X) + Feld(X, Y)
		A = A + Feld(X, Y)
	Next
Next
If A <> 0 Then
	For X = 0 To Seite - 1
		SchwerX = SchwerX + X * AnzahlY(X) / A
		SchwerY = SchwerY + X * AnzahlX(X) / A
	Next
EndIf
;DebugLog SchwerX + "; " + SchwerY

;==[Richtung probieren]--------------------------------------------------------
Local Halb = Seite / 2
Local Winkel, TempX1#, TempX2#, TempY1#, TempY2#
Local Farbe1#, Farbe2#
Dim Fehler(179)
Local WinkelMin

For Winkel = 0 To 179
	For X = 0 To Halb Step 2
		For Y = 0 To Seite - 1 Step 2
			TempX1 = SchwerX - Cos(Winkel) * (Halb - X) + Sin(Winkel) * (Halb - Y)
			TempY1 = SchwerY - Cos(Winkel) * (Halb - Y) - Sin(Winkel) * (Halb - X)
			TempX2 = SchwerX + Cos(Winkel) * (Halb - X) + Sin(Winkel) * (Halb - Y)
			TempY2 = SchwerY - Cos(Winkel) * (Halb - Y) + Sin(Winkel) * (Halb - X)

			If TempX1 => 0 And TempX1 <= Seite-1 And TempY1 => 0 And TempY1 <= Seite-1 Then Farbe1 = Feld(TempX1, TempY1) Else Farbe1 = 0
			If TempX2 => 0 And TempX2 <= Seite-1 And TempY2 => 0 And TempY2 <= Seite-1 Then Farbe2 = Feld(TempX2, TempY2) Else Farbe2 = 0

			If Farbe1 <> Farbe2 Then Fehler(Winkel) = Fehler(Winkel) + Abs(Farbe1 - Farbe2)
		Next
	Next
;	DebugLog LSet(Fehler(Winkel), 8) + Winkel + ""
	If Fehler(Winkel) = 0 Then WinkelMin = Winkel Exit
	If Winkel > 0 Then
		If Fehler(Winkel) < Fehler(WinkelMin) Then
			WinkelMin = Winkel
		EndIf
	EndIf
Next

;==[Einzeichnen]---------------------------------------------------------------
Color 255, 255, 255
Text 10, 10, MilliSecs() - MS + " ms"
Text 10, 25, "Winkel: " + WinkelMin + "; Zuversicht: " + (100 - Fehler(WinkelMin) * 4 / 2.55 / (Seite - 1) / (Seite - 1)) + "%"
Color 0, 0, 128
Rect 94, 94, Seite + 11, Seite + 11
Color 0, 0, 255
Rect 97, 97, Seite + 5, Seite + 5
DrawBlock Bild, 100, 100
Color 255, 0, 0
Line 100+SchwerX-Seite*Sin(WinkelMin),100+SchwerY+Seite*Cos(WinkelMin),100+SchwerX+Seite*Sin(WinkelMin),100+SchwerY-Seite*Cos(WinkelMin)

WaitKey()
End